/**
 *   Lsningsforslag til oppgave nr 2 (basert p eksempel nr 17 i PROG1001).
 *
 *   @file    OPPG_02.CPP
 *   @author  Frode Haug, NTNU
 */


#include <iostream>          //  cout, cin
#include <iomanip>           //  setw
#include <cctype>            //  toupper
using namespace std;


const int MINTEMP   = -70;   ///<  Absolutt laveste mulige temperatur.
const int MAXTEMP   =  70;   ///<  Absolutt hyeste mulige temperatur.
const int MAXNEDBOR = 200;   ///<  Absolutt hyeste mulige nedbr pr.dgn.
const int MINDAGER  =  28;   ///<  Minimum antall dager i en mned.
const int MAXDAGER  =  31;   ///<  Maksimum antall dager i en mned.


/**
 *  Hovedprogrammet:
 */
int main ()  {
  char svar;                 //  Brukersvar til om vil fortsette eller ei.
  int  antDager,             //  Antall dager i aktuell mned.
       min,                  //  Min.temp EN gitt dag.
       max,                  //  Max.temp EN gitt dag.
       nedbor,               //  Nedbr EN gitt dag.
       totMin,               //  TOTALT min.grader i aktuell mned.
       totMax,               //  TOTALT max.grader i aktuell mned.
       totNedbor,            //  TOTALT nedbr i aktuell mned.
       mestNedbor,           //  Mest nedbr falt p en dag.
       nedborDag;            //  Dagnummeret med mest nedbr.

  cout << "\nLese inn vaerdata for en maaned (J/n): ";   //  Kjre programmet?
  cin >> svar;   svar = toupper(svar);


  while (svar != 'N')  {     //  Enn IKKE svart 'N':
     do {                    //  Leser antall dager i mneden (28-31):
        cout << "Antall dager i maaneden ("
             << MINDAGER << '-' << MAXDAGER << "):  ";
        cin >> antDager;
     } while (antDager < MINDAGER  ||  antDager > MAXDAGER);

     totMin = totMax = totNedbor = 0;     //  M huske  nullstille/
     mestNedbor = -1;    nedborDag = 0;   //    initiere variable!

     for (int i = 1;  i <= antDager;  i++)  { //  Gr gjennom HELE mneden:
         cout << "\nDag nr." << setw(2) << i << ":\n";

         do {                             //  Leser korrekt min.temp dag nr.i:
             cout << "\tMinimumstemp (" << setw(2) << MINTEMP
                  << " til " << setw(2) << MAXTEMP << "):  ";
             cin >> min;
         } while(min < MINTEMP ||  min > MAXTEMP);
         totMin += min;                   //  Summerer totalen.

         do {                             //  Leser korrekt max.temp dag nr.i:
             cout << "\tMaksimumstemp (" << setw(2) << min
                  << " til " << setw(2) << MAXTEMP << "):  ";
             cin >> max;
         } while(max < min  ||  max > MAXTEMP);
         totMax += max;                   //  Summerer totalen.

         do {                             //  Leser korrekt nedbr dag nr.i:
            cout << "\tNedbor (0 til " << MAXNEDBOR << "): ";
            cin >> nedbor;
         } while(nedbor < 0  ||  nedbor > MAXNEDBOR);
         totNedbor += nedbor;             //  Summerer totalen.

         if (nedbor > mestNedbor) {       //  Ny nedbrsrekord?
             mestNedbor = nedbor;         //  Lagrer unna rekorden,
             nedborDag = i;               //    og p hvilken dag.
         }
     }

                                    //  Skriver gjennomsnitter og EN totalsum:
     cout << "\n\nGjennomsnittlig min.temp: "
          << static_cast <float> (totMin) / antDager << " grader C\n";
     cout << "Gjennomsnittlig max.temp: "
          << static_cast <float> (totMax) / antDager << " grader C\n";
     cout << "Gjennomsnittlig nedbor:   "
          << static_cast <float> (totNedbor) / antDager << " mm\n";
     cout << "Total nedbor i maaneden:   " << totNedbor <<  " mm\n";
     cout << "Det falt mest nedbor paa dag nr."
          << nedborDag << " med " << mestNedbor << " mm\n";

                                             //  Kjre programmet igjen?
     cout << "\nLese inn vaerdata for en maaned til (J/n): ";
     cin >> svar;   svar = toupper(svar);
  }

  cout << "\n\n\nHa en fortsatt god (vaer(syk))dag!\n\n";

  return 0;
}
