/**
 *   Lsningsforslag til oppgave nr 3.
 *
 *   Modifisert utgave av lsningen til oppgave nr 2: med bruk av funksjoner.
 *
 *   @file    OPPG_03.CPP
 *   @author  Frode Haug, NTNU
 */


#include <iostream>          //  cout, cin
#include <iomanip>           //  setw
using namespace std;


const int MINTEMP   = -70;   ///<  Absolutt laveste mulige temperatur.
const int MAXTEMP   =  70;   ///<  Absolutt hyeste mulige temperatur.
const int MAXNEDBOR = 200;   ///<  Absolutt hyeste mulige nedbr pr.dgn.
const int MINDAGER  =  28;   ///<  Minimum antall dager i en mned.
const int MAXDAGER  =  31;   ///<  Maksimum antall dager i en mned.


float gjennomsnitt(const int verdi1, const int verdi2);
int lesTall(const char t[], const int min, const int max);


/**
 *  Hovedprogrammet:
 */
int main ()  {
  int svar,                 //  Brukersvar til om vil fortsette eller ei.
      antDager,             //  Antall dager i aktuell mned.
      min,                  //  Min.temp EN gitt dag.
      nedbor,               //  Nedbr EN gitt dag.
      totMin,               //  TOTALT min.grader i aktuell mned.
      totMax,               //  TOTALT max.grader i aktuell mned.
      totNedbor,            //  TOTALT nedbr i aktuell mned.
      mestNedbor,           //  Mest nedbr falt p en dag.
      nedborDag;            //  Dagnummeret med mest nedbr.

  svar = lesTall("\nLese inn vaerdata for en maaned", 0, 1);  // Kjre programmet?

  while (svar == 1)  {       //  Enn IKKE svart '0':
                             //  Leser antall dager i mneden (28-31):
     antDager = lesTall("Antall dager i maaneden", MINDAGER, MAXDAGER);

     totMin = totMax = totNedbor = 0;     //  M huske  nullstille/
     mestNedbor = -1;    nedborDag = 0;   //    initiere variable!

     for (int i = 1;  i <= antDager;  i++)  { //  Gr gjennom HELE mneden:
         cout << "\nDag nr." << setw(2) << i << ":\n";
                                          //  Leser korrekt min.temp dag nr.i:
         min = lesTall("Minimumstemp", MINTEMP, MAXTEMP);
         totMin += min;                   //  Summerer totalen.
                                          //  Leser korrekt max.temp dag nr.i:
         totMax += lesTall("Maksimumstemp", min, MAXTEMP); //Summerer totalen.
                                          //  Leser korrekt nedbr dag nr.i:
         nedbor = lesTall("Nedbor", 0, MAXNEDBOR);
         totNedbor += nedbor;             //  Summerer totalen.

         if (nedbor > mestNedbor) {       //  Ny nedbrsrekord?
             mestNedbor = nedbor;         //  Lagrer unna rekorden,
             nedborDag = i;               //    og p hvilken dag.
         }
     }
                                    //  Skriver gjennomsnitter og EN totalsum:
     cout << "\n\nGjennomsnittlig min.temp: "
          << gjennomsnitt(totMin, antDager) << " grader C\n";
     cout << "Gjennomsnittlig max.temp: "
          << gjennomsnitt(totMax, antDager) << " grader C\n";
     cout << "Gjennomsnittlig nedbor:   "
          << gjennomsnitt(totNedbor, antDager) << " mm\n";
     cout << "Total nedbor i maaneden:   " << totNedbor <<  " mm\n";
     cout << "Det falt mest nedbor paa dag nr."
          << nedborDag << " med " << mestNedbor << " mm\n";
                                             //  Kjre programmet igjen?
     svar = lesTall("\nLese inn vaerdata for en maaned til", 0, 1);
  }

  cout << "\n\n\nHa en fortsatt god (vaer(syk))dag!\n\n";

  return 0;
}


/**
 *  Funksjon som beregner float-gjennomsnittet av to int-verdier.
 *
 *  @param     verdi1  - int-verdien over brkstreken
 *  @param     verdi2  - int-verdien under brkstreken
 *  @return    float-verdien av   verdi1 / verdi2
 */
float gjennomsnitt(const int verdi1, const int verdi2) {
    return(static_cast <float> (verdi1) / verdi2);
}


/**
*  Leser og returnerer et heltall mellom to gitte grenser.
*
*  @param   t    - Ledetekst til brukeren nr ber om input/et tall
*  @param   min  - Minimum for innlest og godtatt tallverdi
*  @param   max  - Maksimum for innlest og godtatt tallverdi
*  @return  Godtatt verdi i intervallet 'min' - 'max'
*/
int lesTall(const char t[], const int min, const int max)  {
    int tall;
    do {
       cout << t << " (" << min << " - " << max << "):  ";
       cin >> tall;
    } while (tall < min || tall > max);
    return tall;
}
